#-*- coding:utf-8 -*-

#  Pybik -- A 3 dimensional magic cube game.
#  Copyright (C) 2009  B. Clausius
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License,  or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.


import os

from .version import *


package_dir = os.path.dirname(__file__)
root_dir = os.path.dirname(package_dir)

if not os.path.exists(os.path.join(root_dir, "setup.py")):
    # Running in installed mode
    IMAGE_DIR    = os.path.join(package_dir, 'data', PACKAGE)
    UI_DIR       = os.path.join(package_dir, 'data')
    SCRIPT_DIR   = os.path.join(package_dir, 'data')
else:
    # Running from source directory
    IMAGE_DIR    = os.path.join(root_dir, 'data', PACKAGE)
    UI_DIR       = os.path.join(root_dir, 'data')
    SCRIPT_DIR   = os.path.join(root_dir, 'data')
del package_dir
del root_dir


PACKAGE_NAME = 'Pybik'
APPNAME = _("Pybik")
APPNAME_SHORT = _("Pybik")
COPYRIGHT = 'Copyright \xc2\xa9 2009,  B. Clausius'
DESCRIPTION = _('Pybik is a 3 dimensional magic cube game.')
WEBSITE_LABEL = _('Pybik web site')

LICENSE = [ _('This program is free software; you can redistribute it and/or modify '
            'it under the terms of the GNU General Public License as published by '
            'the Free Software Foundation; either version 3 of the License,  or '
            '(at your option) any later version.'),

            _('This program is distributed in the hope that it will be useful, '
            'but WITHOUT ANY WARRANTY; without even the implied warranty of '
            'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the '
            'GNU General Public License for more details.'),

            _('You should have received a copy of the GNU General Public License '
            'along with this program.  If not, see <http://www.gnu.org/licenses/>.')
        ]


def data_dir():
    try:
        config_dir = os.environ['XDG_CONFIG_HOME']
    except KeyError:
        from .debug import debug
        debug("XDG_CONFIG_HOME not found. defaulting to ~/.config")
        config_dir = os.path.join(os.path.expanduser("~"), ".config")
    return os.path.join(config_dir, "pybik")
    
