#-*- coding:utf-8 -*-

#  Pybik -- A 3 dimensional magic cube game.
#  Copyright (C) 2009  B. Clausius
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License,  or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.


__all__ = ['error','debug','debug_func','deprecated']

def error(*args):
    print 'ERROR:',
    for a in args:
        print a,
    print

def install(module, debug_modes):
    def debug(*args):
        for a in args:
            print a,
        print
    
    for m,v in debug_modes.items():
        setattr(module, m, v)
        __all__.append(m)
    
    module.debug_func = lambda x: x
    if module.DEBUG_FUNC:
        try:
            import decoratorsX
            module.debug_func = decoratorsX.debug
        except:
            pass
    
    module.debug = debug if module.DEBUG_MSG else lambda *args: None
    
    module.deprecated = lambda x: x
    if module.DEBUG_LEVEL >= 0:
        try:
            import decoratorsX
            module.deprecated = decoratorsX.deprecated
        except:
            pass
    
