#-*- coding:utf-8 -*-

#  Pybik -- A 3 dimensional magic cube game.
#  Copyright (C) 2009  B. Clausius
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License,  or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.


# Ported from GNUbik
# Original filename: txfm.c
# Original copyright and license:
#/*
#
#    A little library to do matrix arithmetic
#    Copyright (C) 1998  John Darrington
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License,  or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#*/


#from .debug import *

MATRIX_DIM = 4

#def Matrix(*args):
#    if len(args) <= 1:
#        val = 0.0 if len(args) == 0 else args[0]
#        return [[val] * MATRIX_DIM for __i in xrange(MATRIX_DIM)]
#    assert False
def ZeroMatrix():
    return [[0.0] * MATRIX_DIM for unused_i in xrange(MATRIX_DIM)]
def PtVec(*args):
    if len(args) == 0:
        return [0.0] * MATRIX_DIM
    if len(args) == MATRIX_DIM:
        return list(args)
    assert False, 'Wrong number of arguments'
def Point():
    return [0.0] * MATRIX_DIM
Vector = Point


# Pre-multiply a point or vector x,  by matrix M
#@debug_func
def transform(M, x):
    ## Temporary point variable for result
    #q = PtVec(0, 0, 0, 0)

    ## for each row
    #for i in xrange(MATRIX_DIM):
    #    # for each column
    #    #for j in xrange(MATRIX_DIM):
    #    #    q[i] += M[j][i] * x[j]
    #    q[i] = sum(M[j][i] * x[j] for j in xrange(MATRIX_DIM))
    
    q = [sum(M[j][i] * x[j] for j in xrange(MATRIX_DIM))
         for i in xrange(MATRIX_DIM)]
    return q


# Create a vector by taking the difference of 2 points
def vector_from_points (p1, p2, v):
    v[0] = p2[0] - p1[0]
    v[1] = p2[1] - p1[1]
    v[2] = p2[2] - p1[2]
    v[3] = 0.0

